/* XLanguage - the eXtensible Language
 * Copyright (C) 2001 Patrick Deschenes
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/* These files are distributed at http://www.freesoftware.fsf.org/xlang/
 */

#include <xlvar.h>

XLVar*
xl_var_new (XString* p_name, XLData* p_data)
{
  XLVar *self;

  self = x_new (XLVar);
  x_object_init_object (X_OBJECT (self), xl_var_destroy);
  
  self->name = x_addref (XString, p_name);
  self->data = x_addref (XLData, p_data);
  
  return self;
}

xvoid
xl_var_destroy (XObject* self)
{
  x_unref (XL_VAR (self)->name);
  x_unref (XL_VAR (self)->data);
  
  x_destroy (self);
}

